package fr.natan.akkastreamfileprocessingapi.futurecompleteness;

import scala.Option;
import scala.collection.IndexedSeq;
import scala.concurrent.Future;

import java.util.concurrent.CompletableFuture;
import java.util.concurrent.Executors;
import java.util.concurrent.TimeUnit;


public class CompletableFutureBuilder<T> {

    public static<T> CompletableFuture<T> buildcompletableFuture1(Future<Option<T>> futureT) {
        CompletableFuture<T> completableFuture = new CompletableFuture<>();
        Executors.newSingleThreadExecutor().submit(() -> {
            while(!futureT.isCompleted()){
                TimeUnit.MILLISECONDS.sleep(300);
            }
            T task = futureT.value().get().get().get();
            completableFuture.complete(task);
            return null;
        });

        return completableFuture;
    }

    public static <T> CompletableFuture<IndexedSeq<T>> buildcompletableFuture2(Future<IndexedSeq<T>> futureListT) {

        CompletableFuture<IndexedSeq<T>> completableFuture = new CompletableFuture<>();
        Executors.newSingleThreadExecutor().submit(() -> {
            while (!futureListT.isCompleted()) {
                TimeUnit.MILLISECONDS.sleep(300);
            }

            IndexedSeq<T> task = futureListT.value().get().get();
            completableFuture.complete(task);
            return null;
        });

        return completableFuture;
    }

}
